/***************************** LICENSE START ***********************************

 Copyright 2012 ECMWF and INPE. This software is distributed under the terms
 of the Apache License version 2.0. In applying this license, ECMWF does not
 waive the privileges and immunities granted to it by virtue of its status as
 an Intergovernmental Organization or submit itself to any jurisdiction.

 ***************************** LICENSE END *************************************/

// File Items.h
// Baudouin Raoult - ECMWF Jul 99

#ifndef Items_H
#define Items_H

// Headers
// #ifndef   machine_H
// #include <machine.h>
// #endif

// Forward declarations

// class ostream;
// typedef class _Pvts os_typespec; // Remove if not persistant

// 

#include <string>
using std::string;

#include "Metview.h"
#include "IconObject.h"


class Items {
public:

// -- Exceptions
	// None

// -- Contructors

	Items(request*);

// -- Destructor

	~Items(); // Change to virtual if base class

// -- Convertors
	// None

// -- Operators
	// None

// -- Methods

	IconObject* object();

// -- Overridden methods
	// None

// -- Class members
	// None

// -- Class methods

	static void load(request*);
	static IconObject* find(const string&);
	static void fix(IconObject*);


	// Uncomment for persistent, remove otherwise
	// static os_typespec* get_os_typespec();

protected:

// -- Members
	// None

// -- Methods
	
	// void print(ostream&) const; // Change to virtual if base class	

// -- Overridden methods
	// None

// -- Class members
	// None

// -- Class methods
	// None

private:

// No copy allowed

	Items(const Items&);
	Items& operator=(const Items&);

// -- Members

	request*    r_;
	IconObjectH object_;

// -- Methods
	// None

// -- Overridden methods
	// None

// -- Class members
	// None

// -- Class methods
	// None

// -- Friends

	//friend ostream& operator<<(ostream& s,const Items& p)
	//	{ p.print(s); return s; }

};

inline void destroy(Items**) {}

// If persistent, uncomment, otherwise remove
//#ifdef _ODI_OSSG_
//OS_MARK_SCHEMA_TYPE(Items);
//#endif

#endif
